from bitvector import new_bv, ADD, GE, GT
from gates import background, NOT, Implication, AND
from sat_solver import solve

if __name__ == "__main__":
    formulas = background
    WIDTH = 100
    bv1 = new_bv(WIDTH)
    bv2 = new_bv(WIDTH)

    bv3 = new_bv(WIDTH)
    bv4 = new_bv(WIDTH)
    # we can prove that if bv1 > bv3 and
    # bv2 >= bv4,
    # then bv1 + bv2 > bv3 + bv4
    primese1 = GT(bv1, bv3)
    primese2 = GE(bv2, bv4)
    conclusion = GT(ADD(bv1, bv2), ADD(bv3, bv4))
    thm = Implication(AND(primese1, primese2), conclusion)

    solve([NOT(thm)])
