from pysat.solvers import Cadical

from gates import background


def solve(assumption = None):
    if assumption is None:
        assumption = []
    with Cadical(bootstrap_with=background) as s:
        if s.solve(assumption) == False:
            print("UNSAT")
            return False
        else:
            model = s.get_model()
            return set(model)



